'AutoPasteLoop.bas, version 2.0 (05/01/24)
'Visit: www.pdfhacks.com/autopaste/
'
'Start AutoPasteLoop from MS Word and switch to Adobe Reader or Acrobat.
'Copy the material you want, and AutoPasteLoop will automatically
'paste it into the target Word document.  When you are done, switch back
'to MS Word and AutoPasteLoop will stop.
'
'NOTE: This version of AutoPasteLoop won't stop looping until you switch
'to another application, *copy* something to your clipboard, and switch
'to yet another application.
'
'An excellent tool for copying PDF data using Acrobat/Reader 5/6 is TAPS.
'Download the plug-in from http://pdfhacks.com/TAPS/ and copy it into
'your viewer's plug_ins directory.  E.g.:
'D:\Program Files\Adobe\Acrobat 6.0\Reader\plug_ins
'See PDF Hacks (O'Reilly), Hack #7 for more information on TAPS.

Option Explicit

' declare Win32 API functions that we need
Private Declare Function Sleep Lib "kernel32" (ByVal insdf As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function GetOpenClipboardWindow Lib "user32" () As Long
Private Declare Function GetClipboardOwner Lib "user32" () As Long

Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long
Private Declare Function CountClipboardFormats Lib "user32" () As Long


Sub AutoPasteLoop()
    'this will be the HWND of the application we are copying from
    Dim SourceHwnd As Long
    SourceHwnd = 0
    
    'reset this to stop looping
    Dim KeepLooping As Boolean
    KeepLooping = True
    
    'emtpy clipboard and set owner to NULL
    If OpenClipboard(0) <> 0 Then
        EmptyClipboard
        CloseClipboard
    Else
        MsgBox "Error: Unable to empty clipboard."
        KeepLooping = False 'exit
    End If
    
    Do While KeepLooping
        Sleep 300 'milliseconds; 100 msec == 1/10 sec
        
        'get HWND for currently active application
        Dim ActiveHwnd As Long
        ActiveHwnd = GetForegroundWindow
        Do While GetParent(ActiveHwnd) <> 0
            ActiveHwnd = GetParent(ActiveHwnd)
        Loop
        
        'should we break out of the loop?
        If SourceHwnd <> 0 Then              'we have copied something
            If ActiveHwnd <> SourceHwnd Then 'we have switched windows
                KeepLooping = False          'exit
            End If
        End If
    
        '(ver. 1.0)
        'if the clipboard owner has changed, then somebody else
        'has put something on it; if the clipboard resource isn't
        'locked (GetOpenClipboardWindow), then paste its contents
        'into our document; use Copy to change the clipboard owner
        'back to DocHwnd
        '
        '(ver. 2.0)
        'Hmmm.... with our new technique of zeroing out the clipboard
        'owner, content copied with the TAPS plug-in gets ignored when
        'we test using GetClipboardOwner.  So use CountClipboardFormats,
        'instead.
        '
        If CountClipboardFormats <> 0 And _
        GetOpenClipboardWindow = 0 Then
        
            'paste clipboard into Word document
            Selection.Paste
            
            'emtpy clipboard and set owner to NULL
            If OpenClipboard(0) <> 0 Then
                EmptyClipboard
                CloseClipboard
            Else
                MsgBox "Error: Unable to empty clipboard."
                KeepLooping = False
            End If
            
            'make note of our window, so we know when we have switched out
            SourceHwnd = GetForegroundWindow
            Do While GetParent(SourceHwnd) <> 0
                SourceHwnd = GetParent(SourceHwnd)
            Loop
            
        End If
    Loop
    MsgBox "AutoPasteLoop Exiting."
End Sub
